
package de.ivu.elect.presentation.wahl.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlEdit;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.jee.faces.FacesContextUtil;

public class WahlEntarchivierenAction extends AbstractWahlAction {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlEdit wahlEdit;

  @Override
  public UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHL_ARCHIVIEREN;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Wahl entity) {
    return super.isDisabledInternal(entity) || !entity.getStatus().isArchiviert();
  }

  @Override
  public String doIt(Wahl wahl) {
    wahlEdit.wahlEntarchivieren(wahl);

    messages.addInfoMessage("wahl.edit.action.unlock.success.message", wahl.getName());

    return FacesContextUtil.getCurrentViewId();
  }

  @Override
  public boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getLabelKey() {
    return "wahl.edit.action.unarchive";
  }

  @Override
  public String getIcon() {
    return "fa fa-folder-open";
  }
}
